package ru.dbotthepony.mc.otm.screen;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.capability.android.AndroidFeatureResearchNode;
import ru.dbotthepony.mc.otm.menu.AndroidStationMenu;

import java.util.HashSet;
import java.util.Set;

public class AndroidStationScreen extends PoweredMachineScreen<AndroidStationMenu> {
	private static final ResourceLocation CONTAINER_BACKGROUND = new ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/android_station.png");

	@Override
	protected ResourceLocation CONTAINER_BACKGROUND() {
		return CONTAINER_BACKGROUND;
	}

	private final Set<AndroidFeatureResearchNode> nodes = new HashSet<>();

	public AndroidStationScreen(AndroidStationMenu p_97741_, Inventory p_97742_, Component p_97743_) {
		super(p_97741_, p_97742_, p_97743_);

		for (var feature : Registry.ANDROID_FEATURES().getValues()) {
			var node = feature.getResearchNode();

			if (node != null) {
				nodes.add(node);
			}
		}
	}

	@Override
	public boolean mouseClicked(double mouseX, double mouseY, int p_97750_) {
		int x = leftPos + 40;
		int y = topPos + 10;

		for (var node : nodes) {
			if (mouseX >= x && mouseX <= x + 16 && mouseY >= y && mouseY <= y + 16) {
				node.researchClient();
				return true;
			}
		}

		return super.mouseClicked(mouseX, mouseY, p_97750_);
	}

	@Override
	protected void renderTooltip(PoseStack pose, int mouseX, int mouseY) {
		super.renderTooltip(pose, mouseX, mouseY);

		int x = leftPos + 40;
		int y = topPos + 10;

		for (var node : nodes) {
			if (mouseX >= x && mouseX <= x + 16 && mouseY >= y && mouseY <= y + 16) {
				renderComponentTooltip(pose, node.getTooltip(), mouseX, mouseY);
			}
		}
	}

	@Override
	protected void renderBg(PoseStack pose, float p_97788_, int mouseX, int mouseY) {
		super.renderBg(pose, p_97788_, mouseX, mouseY);
	}
}
